%define realVersion 2.8.11-final
%define name        zope
%define release     1

%define version  %(echo %{realVersion} | sed -e's/-/./g')
%define sVersion %(echo %{realVersion} | cut -d- -f1)

Summary:       The patched version of Zope application server for ERP5
Name:          erp5-%{name}
Version:       %{version}
Release:       %mkrel %{release}
License:       Zope Public License (ZPL)
Group:         System/Servers
URL:           http://www.zope.org
Source0:       http://zope.org/Products/Zope/%{sVersion}/Zope-%{realVersion}.tgz
Source1:       skel-for-rpm.tar.bz2
Source2:       README.install.urpmi.erp5-zope
Source3:       erp5_zeo_server
Source4:       erp5_zeo_client
Source10:      zope-book.tar.bz2
Source11:      zope-devguide.tar.bz2
Patch0:        Zope-2.8.0-final-aq_dynamic.patch
Requires:      python2.4, mailcap
BuildRequires: python2.4-devel
BuildRoot:     %{_tmppath}/%{name}-%{version}-root-%(id -u -n)
Epoch:         1
Provides:      erp5-zope = %{?Epoch:%Epoch-}%{version}
# zope-2.8 includes the following products
Provides:      erp5-ZopeTestCase, erp5-BTreeFolder2, erp5-VerboseSecurity
Obsoletes:     erp5-ZopeTestCase, erp5-BTreeFolder2, erp5-VerboseSecurity

%define python        /usr/bin/python2.4
%define zopehome      /usr/lib/erp5
%define softwarehome  %{zopehome}/lib/python
%define instancehome  /var/lib/erp5
%define clienthome    %{instancehome}/data
%define statehome     /var/run/erp5
%define loghome       /var/log/erp5
%define configfile    /etc/zope-erp5.conf
%define zopectl       /usr/bin/zopectl-erp5
%define runzope       /usr/bin/runzope-erp5
%define zopeuser      zope
%define service       erp5

%description
Zope is an open source application server for building content managements,
intranets, portals, and custom applications. The Zope community consists of
hundreds of companies and thousands of developers all over the world, working
on building the platform and Zope applications. Zope is written in Python, a
highly-productive, object-oriented scripting language.

This version contain a patch from Nexedi about dynamic acquisition in order to
make ERP5 working well.

%prep
%setup -q -n Zope-%{realVersion} -a 1 -a 10 -a 11

%patch0 -p1

# remove needless executable permission
find doc lib skel/import import -type f -perm /111 -exec chmod -x {} \;

find lib/python -type f -and \( -name 'Setup' -or -name '.cvsignore' \) \
    -exec rm -f \{\} \;
find -name "Win32" | xargs rm -rf
rm -f ZServer/medusa/monitor_client_win32.py

cp -p %{SOURCE2} README.install.urpmi

for dir in Constraint Document PropertySheet bt5 tests; do
  mkdir -p skel/$dir;
done

%build
mkdir -p build
pushd build
../configure \
  --with-python="%{python}" \
  --prefix="%{buildroot}%{zopehome}" \
  --no-compile
make build
popd

%install
%{__rm} -rf %{buildroot}
%{python} "utilities/copyzopeskel.py" \
         --sourcedir="skel-for-rpm" \
         --targetdir="%{buildroot}" \
         --replace="INSTANCE_HOME:%{instancehome}" \
         --replace="CLIENT_HOME:%{clienthome}" \
         --replace="STATE_DIR:%{statehome}" \
         --replace="LOG_DIR:%{loghome}" \
         --replace="SOFTWARE_HOME:%{softwarehome}" \
         --replace="ZOPE_HOME:%{zopehome}" \
         --replace="CONFIG_FILE:%{configfile}" \
         --replace="PYTHON:%{python}" \
         --replace="ZOPECTL:%{zopectl}" \
         --replace="RUNZOPE:%{runzope}"

pushd build
make install
popd
%py_compile %{buildroot}%{softwarehome}

# Remove old log
rm -rf %{buildroot}/var/log/zope

# Create new log dir
mkdir -p %{buildroot}%{loghome}
touch %{buildroot}%{loghome}/event.log
touch %{buildroot}%{loghome}/Z2.log

# Rename binaries
mv %{buildroot}/usr/bin/zopectl %{buildroot}/%{zopectl}
mv %{buildroot}/usr/bin/runzope %{buildroot}/%{runzope}
mv %{buildroot}/etc/rc.d/init.d/zope %{buildroot}/etc/rc.d/init.d/%{service}
mv %{buildroot}/etc/zope.conf %{buildroot}/%{configfile}
mv %{buildroot}/etc/logrotate.d/zope %{buildroot}/etc/logrotate.d/%{service}
mv %{buildroot}/var/lib/zope %{buildroot}/%{instancehome}
mv %{buildroot}/var/run/zope %{buildroot}/%{statehome}

# Install startup scripts for ZEO servers and ZEO clients
cp -a %{SOURCE3} %{SOURCE4} %{buildroot}/etc/rc.d/init.d/

%clean
rm -rf %{buildroot}

%pre
%_pre_useradd %{zopeuser} %{instancehome} /bin/false

%post
%_post_service %{service}
%_post_service erp5_zeo_server
%_post_service erp5_zeo_client

%preun
%_preun_service %{service}
%_preun_service erp5_zeo_client
%_preun_service erp5_zeo_server

%postun
%_postun_userdel %{zopeuser}

%files
%defattr(-,root,root,755)
%{zopehome}
%{runzope}
%{zopectl}
%config(noreplace) /etc/rc.d/init.d/%{service}
%config(noreplace) /etc/rc.d/init.d/erp5_zeo_client
%config(noreplace) /etc/rc.d/init.d/erp5_zeo_server
%config(noreplace) %{configfile}
%config(noreplace) /etc/logrotate.d/%{service}

%attr(-,%{zopeuser},%{zopeuser}) %config(noreplace) %verify(not md5 size mtime) %{instancehome}
%attr(-,%{zopeuser},%{zopeuser}) %dir %{statehome}
%attr(-,%{zopeuser},%{zopeuser}) %dir %{loghome}
%ghost %{loghome}/Z2.log
%ghost %{loghome}/event.log

%doc README.install.urpmi

##############################################################################

%package docs
Summary:    Documentation for the Zope application server
Group:      Networking/WWW

%description docs
Documentation for the Z Object Programming Environment (Zope), a free, Open
Source Python-based application server for building high-performance, dynamic
web sites, using a powerful and simple scripting object model and
high-performance, integrated object database.

%files docs
%defattr(-,root,root,755)
%doc doc zope-book zope-devguide

%changelog
* Thu Aug  6 2009 Kazuhiko Shiozaki <kazuhiko@nexedi.com> 2.8.11.final-1nxd2009.1
- Zope 2.8.11.
  + Launchpad #373299: Removed bogus string exception in OFS.CopySupport.
  + Fixed vulnerabilities in the ZEO network protocol affecting ZEO storage servers.

* Fri Oct 31 2008 Kazuhiko Shiozaki <kazuhiko@nexedi.com> 2.8.10.final-1nxd2008.1
- Zope 2.8.10.
  + Ensure that response header values cannot embed CRLF pairs, which
    violate the HTTP spec (RFC 2616).
  + 'AccessControl.ZopeGuards.guarded_import' mapped some Unauthorized
    exceptions onto ImportErrors:  don't do that!  Also, removed
    mutable defaults from argument list, improved tests.
  + LP #281156:  'AccessControl.SecurityInfo.secureModule' dropped
    ModuleSecurity for failed imports, obscuring later attempts to
    import the same broken module.
  + LP #142667:  Updated to ZODB-3.4.5 to fix problem with product
    auto-refresh.
  + Collector #2318: Allow override of zopectl's control socket in
    zope.conf
  + integrated Hotfix-2008-08-12
- add startup scripts for ZEO servers and ZEO clients under
  /var/lib/erp5.
- update logrotate.d/erp5 for ZEO servers and ZEO clients under
  /var/lib/erp5.

* Thu Oct  9 2008 Kazuhiko Shiozaki <kazuhiko@nexedi.com> 2.8.9.1.final-5nxd2008.1
- require mailcap package for better mimetype support.
- add Constraint, Document, PropertySheet, bt5, and tests directories.

* Tue Oct 23 2007 Kazuhiko Shiozaki <kazuhiko@nexedi.com> 2.8.9.1.final-4mdv2007.1
- modify Requires and BuildRequires.

* Wed Oct 10 2007 Kazuhiko Shiozaki <kazuhiko@nexedi.com> 2.8.9.1.final-3mdv2007.1
- revise ownership of directories.

* Mon Sep 17 2007 Yoshinori Okuji <yo@nexedi.com> 2.8.9.1.final-2mdv2007.1
- Include README.install.urpmi.erp5-zope.

* Wed Sep  5 2007 Kazuhiko Shiozaki <kazuhiko@nexedi.com> 2.8.9.1.final-1mdv2007.1
- upgrade to Zope-2.8

* Sun May 13 2007 Jean-Paul Smets <jp@nexedi.com> 2.7.8-9mdv2007.0
- make paths completely generic

* Tue Jan 23 2007 Kevin Deldycke <kevin@nexedi.com> 2.7.8-8mdv2007.0
- Generate empty log files

* Mon Jan 22 2007 Kevin Deldycke <kevin@nexedi.com> 2.7.8-7mdv2007.0
- Rebuild for Mandriva 2007.0

* Tue Aug 29 2006 Kevin Deldycke <kevin@nexedi.com> 2.7.8-6nxd
- Compile every python script, not just the one in lib directory.
- Cleanup patch

* Fri Apr 14 2006 Kevin Deldycke <kevin@nexedi.com> 2.7.8-5nxd
- Remove conflict with "python-zope-interface" which was too violent

* Fri Apr 14 2006 Kevin Deldycke <kevin@nexedi.com> 2.7.8-4nxd
- Add "python-zope-interface" as a conflict package
- Required package for build is libpython-devel not python-devel

* Tue Jan 24 2006 Kevin Deldycke <kevin@nexedi.com> 2.7.8-3nxd
- Doc package doesn't requires zope
- Add Epoch tag
- Add "Conflicts: zope"
- Add version to "Provides" statement

* Wed Jan 5 2006 Kevin Deldycke <kevin@nexedi.com> 2.7.8-2nxd
- Rewrite spec file based on the one written by Gaetan Lehmann for the zope-2.7.7 release for Mandriva 2006
- Add 'erp5' prefix to package name
- Add README.install.urpmi.zope
- Remove default admin user

* Fri Oct 28 2005 Yoshinori Okuji <yo@nexedi.com> 2.7.8-1nxd
- New upstream release

* Wed Oct 12 2005 Yoshinori Okuji <yo@nexedi.com> 2.7.7b1-1nxd
- New upstream release

* Sun Apr 24 2005 Yoshinori Okuji <yo@nexedi.com> 2.7.6b2-2nxd
- Rebuild against Python 2.4

* Thu Apr 21 2005 Yoshinori Okuji <yo@nexedi.com> 2.7.6b2-1nxd
- Bump to Zope 2.7.6b2

* Thu Feb 3 2005 Yoshinori Okuji <yo@nexedi.com> 2.7.2rc1-3nxd
- The source tarball was not bzip2'ed even though the suffix was bz2

* Tue Feb 1 2005 Yoshinori Okuji <yo@nexedi.com> 2.7.2rc1-2nxd
- Fix the method bounding in _aq_dynamic

* Mon Aug 2 2004 Yoshinori Okuji <yo@nexedi.com> 2.7.2rc1-1nxd
- Bump to 2.7.2rc1
- Patch Acquistion to support _aq_dynamic

* Sat Feb 07 2004 Stéfane Fermigier <sf@nuxeo.com> 2.7.0rc2-1mdk
- Bump to Zope 2.7.0rc2

* Sun Jan 11 2004 Stéfane Fermigier <sf@nuxeo.com> 2.7.0b4-1mdk
- Bump to Zope 2.7.0b4

* Sun Sep 14 2003 Stéfane Fermigier <sf@nuxeo.com> 2.7.0b2-1pyp
- Update to Zope 2.7.0b2

* Fri Aug 15 2003 Stéfane Fermigier <sf@nuxeo.com> 2.7.0b1-3pyp
- Update for Python 2.3

* Sat Aug 9 2003 Stéfane Fermigier <sf@nuxeo.com> 2.7.0b1-2pyp
- Added copyright notice
- Compile to .pyc as well as to .pyo

* Sat Jul 26 2003 Stéfane Fermigier <sf@nuxeo.com> 2.7.0b1-1mdk
- Update to Zope 2.7.0b1
- Merged stuff from the Zope.org RPM

* Sat May 3 2003 Stéfane Fermigier <sf@nuxeo.com> 2.6.1-6mdk
- Moved python stuff from /usr/lib/zope to /usr/lib/zope/lib/python

* Mon Mar 24 2003 Stéfane Fermigier <sf@nuxeo.com> 2.6.1-5mdk
- Moved python stuff from /usr/lib/zope to /usr/lib/zope/lib/python

* Tue Feb 25 2003 Stéfane Fermigier <sf@nuxeo.com> 2.6.1-4mdk
- changes by Frederic Lepied
- fixed dependency problem between zope-docs and zope
- removed unused directive

* Sun Feb 23 2003 Stéfane Fermigier <sf@nuxeo.com> 2.6.1-3mdk
- fix bugs

* Sat Feb 22 2003 Stéfane Fermigier <sf@nuxeo.com> 2.6.1-2mdk
- dont ship tests
- separate docs package, including the Zope Book.

* Sat Feb 22 2003 Stéfane Fermigier <sf@nuxeo.com> 2.6.1-1mdk
- First release starting from PLD RPM.
